//AdapterImages_404f.js
// 26.10.09 / Hans Haesler, Chtelard 52, CH-1018 Lausanne / <hsa@ringier.ch>
//Ce script sert  adapter les images slectionnes  leur bloc

// tester si un document est ouvert
if (app.documents.length == 0) {
	alert ("Il n'y a pas de document ouvert.", "Attention");
	exit();
}

// tester la slection
selItems = app.selection;
nItems = selItems.length;
if (nItems == 0) {
	alert ("Il n'y a pas de slection.", "Attention");
	exit();
}

// une boucle de rptition  travers les blocs slectionns
var curSel;
var curType;
for (var i=0; i<nItems; i++) {
	curSel = selItems[i];
	curType = curSel.constructor.name;
	if (curType == "Rectangle") {
		fitImage(curSel);
	}
	else if (curType == "Image") {
		curSel = curSel.parent;
		fitImage(curSel);
	}
	else if (curType == "Group") {
		parseGroup(curSel);
	}
}

// la fonction pour adapter l'image au bloc actuel
function fitImage(curSel) {
	try {
		var curImg = curSel.allGraphics[0];
		// remplir le bloc en respectant les proportions
		curImg.fit(FitOptions.fillProportionally);
		// mmoriser le pourcentage
		var oldPc = curImg.horizontalScale;
		// ajouter 0.5% et arrondir la valeur  une position dcimale
		var newPc = Math.ceil((oldPc + 0.5)*10) / 10;
		// appliquer la nouvelle valeur
		curImg.properties = {horizontalScale:newPc, verticalScale:newPc};
		// centrer l'image
		curSel.allGraphics[0].fit(FitOptions.centerContent);
	}
	catch (e) {
	}
}

// la fonction pour examiner les groupes
function parseGroup(curGroup) {
	var allFrames = curGroup.allPageItems;
	var curFrame;
	var curType;
	for (var i=0; i< allFrames.length; i++) {
		curFrame = allFrames[i];
		curType = curFrame.constructor.name;
		// comme ci-dessus, le type de l'objet est examin, 
		// la rfrence est complte (si ncessaire) 
		// et envoye  la fonction 'fitImage'
		if (curType == "Rectangle") {
			fitImage(curFrame);
		}
		else if (curType == "Image") {
			curFrame = curFrame.parent;
			fitImage(curFrame);
		}
	}
}